//////////////////////////////////////////////////////////////////////////////// 
/// Pseudoglobe Screensaver
/// 
/// Copyright  2002  Sebastian Pipping <webmaster@hartwork.org>
/// 
/// -->  http://www.hartwork.org
/// 
/// This source code is released under the GNU General Public License (GPL).
/// See GPL.txt for details. Any non-GPL usage is strictly forbidden.
////////////////////////////////////////////////////////////////////////////////


#include "csaver.h"

CSaver::CSaver()
{
	// Parse commandline
	char * szCommandLine = GetCommandLine();
	if( *szCommandLine == '\"' )
	{
		szCommandLine++;
		while( ( *szCommandLine != '\0' ) && ( *szCommandLine!='\"' ) )
		{
			szCommandLine++;
		}
	}
	else
	{
		while( ( *szCommandLine != '\0' ) && ( *szCommandLine != ' ' ) )
		{
			szCommandLine++;
		}
	}

	if( *szCommandLine != 0 )
	{
		szCommandLine++;
	}

	while( *szCommandLine == ' ' )
	{
		szCommandLine++;
	}

	// Parse parameters
	if( *szCommandLine == '\0' )
	{
		hParent = NULL;

		// Open config dialog
		iMode = MODE_CONFIG;
	}
	else
	{
		if( ( *szCommandLine == '-' ) || ( *szCommandLine == '/' ) )
		{
			szCommandLine++;
		}
		if( ( *szCommandLine == 'p' ) || ( *szCommandLine == 'P' ) || ( *szCommandLine == 'l' ) || ( *szCommandLine == 'L' ) )
		{
			szCommandLine++;
			while( ( *szCommandLine == ' ' ) || ( *szCommandLine == ':' ) )
			{
				szCommandLine++;
			}
			hParent = ( HWND )atoi( szCommandLine );

			// Run in preview window
			iMode = MODE_PREVIEW;
		}
		else if( ( *szCommandLine == 's' ) || ( *szCommandLine == 'S' ) )
		{
			hParent = NULL;

			// Run in preview window
			iMode = MODE_FULLSCREEN;
		}
		else if( ( *szCommandLine == 'c' ) || ( *szCommandLine == 'C' ) )
		{
			szCommandLine++;
			while( ( *szCommandLine == ' ' ) || ( *szCommandLine == ':' ) )
			{
				szCommandLine++;
			}
			if( *szCommandLine == '\0' )
			{
				hParent = GetForegroundWindow();
			}
			else
			{
				hParent = ( HWND )atoi( szCommandLine );
			}

			// Open config dialog
			iMode = MODE_CONFIG;
		}
		else if( ( *szCommandLine == 'a' ) || ( *szCommandLine == 'A' ) )
		{
			szCommandLine++;
			while( ( *szCommandLine == ' ' ) || ( *szCommandLine == ':' ) )
			{
				szCommandLine++;
			}
			hParent = ( HWND )atoi( szCommandLine );

			// Open password dialog
			iMode = MODE_PASSWORD;
		}
	}
}
